﻿//-----------------------------------------------
//TUSB-S01VIN1用ドライバアクセス用API
//Visual C# 用モジュール
//
//2017_04_27　株式会社タートル工業
//Copyright (C) 2017 Turtle Industry Co.,Ltd.
//-----------------------------------------------

using System.Runtime.InteropServices;

class TUSBSVI1
{
    //API関数宣言

    [DllImport("TUSBSVI1.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbs01vin1_Device_Open(short id);
    [DllImport("TUSBSVI1.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern void Tusbs01vin1_Device_Close(short id);
    [DllImport("TUSBSVI1.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbs01vin1_Timer_Set(short id, byte ClockN, int ClockM);
    [DllImport("TUSBSVI1.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbs01vin1_Input_Set(short id, byte Range);
    [DllImport("TUSBSVI1.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbs01vin1_Sampling_Start(short id, byte TrType, short Level, int PreLen, int TotalLen);
    [DllImport("TUSBSVI1.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbs01vin1_Status_Read(short id, out byte status, out byte ovf, out int leng);
    [DllImport("TUSBSVI1.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbs01vin1_Memory_Read(short id, [Out] short[] data, ref int leng);
    [DllImport("TUSBSVI1.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbs01vin1_Sampling_Stop(short id);
    [DllImport("TUSBSVI1.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbs01vin1_Memory_Clear(short id);
    [DllImport("TUSBSVI1.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbs01vin1_Sampling_Trigger(short id);
    [DllImport("TUSBSVI1.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbs01vin1_FifoPeak(short id, out byte Peak);

    public static string GetErrMessage(short retcode)
    {
        switch (retcode)
        {
            case 0:
                return "正常終了しました";
            case 1:
                return "ID番号が不正です";
            case 2:
                return "ドライバがインストールされていません";
            case 3:
                return "すでにデバイスはオープンされています";
            case 4:
                return "接続されている台数が多すぎます";
            case 5:
                return "オープンできませんでした";
            case 6:
                return "デバイスがみつかりません";
            case 7:
                return "オープンされていません";
            case 8:
                return "パラメータエラー";
            case 9:
                return "USB通信エラーです";
            default:
                return "不明なエラーです";
        }
    }
}

